Index: src/rtgsnmp.c
===========================================================================
--- src/rtgsnmp.c	2004/11/03 14:26:17	#4
+++ src/rtgsnmp.c	2004/11/03 14:26:17
@@ -3,10 +3,14 @@
    Author:      $Author: cbrotsos $
    Date:        $Date: 2004/04/22 18:33:54 $
    Description: RTG SNMP Routines
+   Do You:      $Yahoo$
 ****************************************************************************/
 
 #include "common.h"
 #include "rtg.h"
+#include "rtghash.h"
+#include "rtgsqlbuf.h"
+#include "rtgsnmp.h"
 
 #ifdef OLD_UCD_SNMP
  #include "asn1.h"
@@ -20,16 +24,17 @@
  #include "net-snmp-includes.h"
 #endif
 
+struct rtg_oid {
+	oid Oid[MAX_OID_LEN];
+	size_t OidLen;
+};
+
 extern target_t *current;
-extern stats_t stats;
-
-#ifndef FEATURES
-/* REB - goes away if each thread starts own DB connection */
-extern MYSQL mysql;
-#endif
 
 #ifdef FEATURES
-void cancel_lock(void *arg)
+static void cancel_lock(void *arg);
+static void
+cancel_lock(void *arg)
 {
     /* to be called from the cleanup handler */
     PT_MUTEX_UNLOCK(arg);
@@ -42,30 +47,29 @@
     crew_t *crew = worker->crew;
     target_t *entry = NULL;
     void *sessp = NULL;
-    struct snmp_session session;
     struct snmp_pdu *pdu = NULL;
     struct snmp_pdu *response = NULL;
-    oid anOID[MAX_OID_LEN];
-    size_t anOID_len = MAX_OID_LEN;
     struct variable_list *vars = NULL;
-    unsigned long long result = 0;
-    unsigned long long last_value = 0;
-    unsigned long long insert_val = 0;
-    int poll_status = 0, db_status = 0, bits = 0, init = 0;
+    struct timeval current_time;
+    struct timezone tzp;
+#ifdef HAVE_UNSIGNED_LONG_LONG
+    unsigned long long result;
+    unsigned long long last_value;
+    unsigned long long insert_val;
+#else
+    unsigned long result;
+    unsigned long last_value;
+    unsigned long insert_val;
+#endif
+    int poll_status, bits;
     char query[BUFSIZE];
-    char storedoid[BUFSIZE];
-    char result_string[BUFSIZE];
 
 #ifdef FEATURES
 	/* Per thread SQL connection testing */
-  #if HAVE_MYSQL
-	MYSQL mysql;
-  #elif HAVE_PGSQL
+  #if HAVE_PGSQL
 	PGconn *pgsql;
   #endif
 	double rate = 0;
-	struct timezone tzp;
-	struct timeval current_time;
 	struct timeval last_time;
 
 	/* for thread settings */
@@ -73,16 +77,8 @@
 #endif
 
 	debug(HIGH, "Thread [%d] starting.\n", worker->index);
-#if HAVE_MYSQL
-    if (MYSQL_VERSION_ID > 40000)
-       mysql_thread_init();
-    else 
-       my_thread_init();
-
-    pthread_cleanup_push(mysql_close_db, &mysql);
+#if HAVE_PGSQL
 
-#elif HAVE_PGSQL
-
     pthread_cleanup_push(pgsql_close_db, pgsql);
 
 #endif
@@ -92,14 +88,7 @@
 #ifdef FEATURES
 	/* Per thread MySQL connection testing */
     if (!(set.dboff)) {
-#if HAVE_MYSQL
-		if (mysql_dbconnect(set.dbdb, &mysql) < 0) 
-			fatal("** Database error - check configuration.\n");
-		if (!mysql_ping(&mysql))
-			debug(LOW, "connected.\n");
-		else
-			fatal("server not responding.\n");
-#elif HAVE_PGSQL
+#if HAVE_PGSQL
 		pgsql = PQsetdbLogin(set.dbhost, NULL, NULL, NULL, 
 					set.dbdb, set.dbuser, set.dbpass);
 		if (PQstatus(pgsql) != CONNECTION_OK) {
@@ -123,6 +112,7 @@
 #endif
 	debug(DEVELOP, "Thread [%d] locking (wait on work)\n", worker->index);
 
+	SPT("waiting for work");
 	PT_MUTEX_LOCK(&crew->mutex);
 #ifdef FEATURES
 	/* add an unlock to the cancel stack */
@@ -132,190 +122,217 @@
 	while (current == NULL) {
 		PT_COND_WAIT(&crew->go, &crew->mutex);
 	}
-	debug(DEVELOP, "Thread [%d] done waiting, received go (work cnt: %d)\n",
-		worker->index, crew->work_count);
 
-	if (current != NULL) {
-		debug(HIGH, "Thread [%d] processing %s %s (%d work units remain in queue)\n",
-			worker->index, current->host, current->objoid, crew->work_count);
-	    snmp_sess_init(&session);
-#if NEW_TARGET_FORMAT
-		if (current->host->snmp_ver == 2)
-			session.version = SNMP_VERSION_2c;
-		else
-			session.version = SNMP_VERSION_1;
-	    session.peername = current->host->host;
-	    session.community = current->host->community;
-#else
-		if (set.snmp_ver == 2)
-	      session.version = SNMP_VERSION_2c;
-		else
-	      session.version = SNMP_VERSION_1;
-	    session.peername = current->host;
-	    session.community = current->community;
-#endif
-		session.remote_port = set.snmp_port;
-	    session.community_len = strlen(session.community);
-
-	    sessp = snmp_sess_open(&session);
-	    anOID_len = MAX_OID_LEN;
+	debug(DEVELOP,
+	    "Thread [%hu] done waiting, received go (work cnt: %u)\n",
+	    worker->index, crew->work_count);
+	    entry = current;
+	    current = tgthash_next(thash);
+		debug(DEVELOP,
+		    "Thread [%d] processing %s %s (%d work units remain in queue)\n",
+		    worker->index, entry->host->s->peername, entry->objoid,
+		    crew->work_count);
+	SPT("polling %s (%s)", entry->host->s->peername, entry->objoid);
+	    sessp = snmp_sess_open(entry->host->s);
 	    pdu = snmp_pdu_create(SNMP_MSG_GET);
-	    read_objid(current->objoid, anOID, &anOID_len);
-	    entry = current;
-	    last_value = current->last_value;
+	    response = NULL;
+	    last_value = entry->last_value;
 #ifdef FEATURES
-		/* save the time so we can calculate rate */
-		last_time = current->last_time;
+	    /* save the time so we can calculate rate */
+	    last_time = entry->last_time;
 #endif
-	    init = current->init;
 	    insert_val = 0;
-	    bits = current->bits;
-	    strncpy(storedoid, current->objoid, sizeof(storedoid));
-		current = getNext();
-	}
-	debug(DEVELOP, "Thread [%d] unlocking (done grabbing current)\n", worker->index);
+	    result = 0;
+	    bits = entry->bits;
+	debug(DEVELOP, "Thread [%d] unlocking (done grabbing current)\n",
+	    worker->index);
 	PT_MUTEX_UNLOCK(&crew->mutex);
 #ifdef FEATURES
 	/* take the unlock off the cancel stack */
 	pthread_cleanup_pop(FALSE);
 #endif
 
-	snmp_add_null_var(pdu, anOID, anOID_len);
-	if (sessp != NULL) 
+	snmp_add_null_var(pdu, entry->oid->Oid, entry->oid->OidLen);
+	if (sessp != NULL) {
+	   unsigned int x;
+	   for (x = 1; pthread_mutex_trylock(&entry->host->mutex); x++)
+		   usleep(250000 / x);
 	   poll_status = snmp_sess_synch_response(sessp, pdu, &response);
-	else
+	   PT_MUTEX_UNLOCK(&entry->host->mutex);
+	} else
 	   poll_status = STAT_DESCRIP_ERROR;
 
 	/* Collect response and process stats */
 	PT_MUTEX_LOCK(&stats.mutex);
 	if (poll_status == STAT_DESCRIP_ERROR) {
+	    entry->init = ERR;
 	    stats.errors++;
-            printf("*** SNMP Error: (%s) Bad descriptor.\n", session.peername);
+            debug(LOW, "*** SNMP Error: (%s) Bad descriptor.\n",
+	       entry->host->s->peername);
 	} else if (poll_status == STAT_TIMEOUT) {
+	    if (entry->init == TIME)
+		entry->init = ERR;
+	    else
+		entry->init = TIME;
 	    stats.no_resp++;
-	    printf("*** SNMP No response: (%s@%s).\n", session.peername,
-	       storedoid);
+	    debug(LOW, "*** SNMP No response: (%s@%s).\n",
+	       entry->host->s->peername, entry->objoid);
 	} else if (poll_status != STAT_SUCCESS) {
+	    entry->init = ERR;
 	    stats.errors++;
-	    printf("*** SNMP Error: (%s@%s) Unsuccessuful (%d).\n", session.peername,
-	       storedoid, poll_status);
+	    debug(LOW, "*** SNMP Error: (%s@%s) Unsuccessful (%d).\n",
+	       entry->host->s->peername, entry->objoid, poll_status);
 	} else if (poll_status == STAT_SUCCESS && response->errstat != SNMP_ERR_NOERROR) {
+	    entry->init = ERR;
 	    stats.errors++;
-	    printf("*** SNMP Error: (%s@%s) %s\n", session.peername,
-	       storedoid, snmp_errstring(response->errstat));
+	    debug(LOW, "*** SNMP Error: (%s@%s) %s\n", entry->host->s->peername,
+	       entry->objoid, snmp_errstring(response->errstat));
 	} else if (poll_status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR && response->variables->type == SNMP_NOSUCHINSTANCE) {
+	    entry->init = ERR;
 	    stats.errors++;
-	    printf("*** SNMP Error: No Such Instance Exists (%s@%s)\n", session.peername, storedoid);
+	    debug(LOW, "*** SNMP Error: No Such Instance Exists (%s@%s)\n",
+	       entry->host->s->peername, entry->objoid);
 	} else if (poll_status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR) {
 	    stats.polls++;
-	} 
+	    if (entry->init == TIME)
+		entry->init = LIVE;
+	} else if (poll_status == STAT_ERROR) {
+	    entry->init = ERR;
+	    stats.errors++;
+	    debug(LOW, "*** SNMP Poll Error: (%s@%s) %s\n",
+		entry->host->s->peername, entry->objoid,
+		snmp_errstring(response->errstat));
+	}
 	PT_MUTEX_UNLOCK(&stats.mutex);
 
 	/* Liftoff, successful poll, process it */
-#ifdef FEATURES
+
 	/* Get the current time */
 	gettimeofday(&current_time, &tzp);
-#endif
 
-	if (poll_status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR && response->variables->type != SNMP_NOSUCHINSTANCE) {
+	if (poll_status == STAT_SUCCESS && response &&
+	    response->errstat == SNMP_ERR_NOERROR &&
+	    response->variables->type != SNMP_NOSUCHINSTANCE) {
+	    const char *d;
+	    enum debugLevel dl = DEBUG;
 	    vars = response->variables;
-#ifdef OLD_UCD_SNMP
-            sprint_value(result_string, anOID, anOID_len, vars);
-#else
-	    snprint_value(result_string, BUFSIZE, anOID, anOID_len, vars);
-#endif
 	    switch (vars->type) {
 		/*
 		 * Switch over vars->type and modify/assign result accordingly.
 		 */
 		case ASN_COUNTER64:
-		    debug(DEBUG, "64-bit result: (%s@%s) %s\n", session.peername, storedoid, result_string);
+		    d = "64-bit result: (%s@%s) %s\n";
 		    result = vars->val.counter64->high;
-		    result = result << 32;
-		    result = result + vars->val.counter64->low;
+		    result <<= 32;
+		    result += vars->val.counter64->low;
+		    if (bits != 64)
+			    debug(LOW, "%s@%s is 64 bits!\n", entry->objoid,
+				  entry->host->s->peername);
 		    break;
 		case ASN_COUNTER:
-		    debug(DEBUG, "32-bit result: (%s@%s) %s\n", session.peername, storedoid, result_string);
+		    d = "32-bit result: (%s@%s) %s\n";
+		    if (bits != 32)
+			    debug(LOW, "%s@%s is 32 bits!\n", entry->objoid,
+				  entry->host->s->peername);
 		    result = (unsigned long) *(vars->val.integer);
 		    break;
 		case ASN_INTEGER:
-		    debug(DEBUG, "Integer result: (%s@%s) %s\n", session.peername, storedoid, result_string);
+		    d = "Integer result: (%s@%s) %s\n";
+		    if (bits != 32)
+			    debug(LOW, "%s@%s is 32 bits!\n", entry->objoid,
+				  entry->host->s->peername);
 		    result = (unsigned long) *(vars->val.integer);
 		    break;
 		case ASN_GAUGE:
-		    debug(DEBUG, "32-bit gauge: (%s@%s) %s\n", session.peername, storedoid, result_string);
+		    d = "32-bit gauge: (%s@%s) %s\n";
 		    result = (unsigned long) *(vars->val.integer);
 		    break;
 		case ASN_TIMETICKS:
-		    debug(DEBUG, "Timeticks result: (%s@%s) %s\n", session.peername, storedoid, result_string);
+		    d = "Timeticks result: (%s@%s) %s\n";
 		    result = (unsigned long) *(vars->val.integer);
 		    break;
 		case ASN_OPAQUE:
-		    debug(DEBUG, "Opaque result: (%s@%s) %s\n", session.peername, storedoid, result_string);
+		    d = "Opaque result: (%s@%s) %s\n";
 		    result = (unsigned long) *(vars->val.integer);
 		    break;
 		case ASN_OCTET_STR:
-		    debug(DEBUG, "String Result: (%s@%s) %s\n", session.peername, storedoid, result_string);
-#ifdef HAVE_STRTOLL
-		    result = strtoll(vars->val.string, NULL, 0);
+		    d = "String Result: (%s@%s) %s\n";
+#ifdef HAVE_STRTOULL
+		    result = strtoull(vars->val.string, NULL, 0);
 #else
-		    result = strtol(vars->val.string, NULL, 0);
+		    result = strtoul(vars->val.string, NULL, 0);
 #endif
 		    break;
 		default:
-		    debug(LOW, "Unknown result type: (%s@%s) %s\n", session.peername, storedoid, result_string);
+		    d = "Unknown result type: (%s@%s) %s\n";
+		    dl = LOW;
+		    entry->init = ERR;
+		    result = 0;
+		    PT_MUTEX_LOCK(&stats.mutex);
+		    stats.polls--;
+		    stats.errors++;
+		    PT_MUTEX_UNLOCK(&stats.mutex);
+		    break;
+	    }
+	    if (set.verbose >= dl) {
+		char result_string[BUFSIZE];
+#ifdef OLD_UCD_SNMP
+		sprint_value(result_string, entry->oid->Oid,
+                             entry->oid->OidLen, vars);
+#else
+		snprint_value(result_string, BUFSIZE, entry->oid->Oid,
+			      entry->oid->OidLen, vars);
+#endif
+		debug(OFF, d, entry->host->s->peername, entry->objoid,
+		      result_string);
 	    }
 
-		/* Gauge Type */
-		if (bits == 0) {
-			if (result != last_value) {
+	    if (bits == 0) {
+		if (result != last_value) {
+			insert_val = result;
+			debug(HIGH,
+			    "Thread [%u]: Gauge change from %llu to %llu\n",
+			    worker->index, last_value, insert_val);
+		} else {
+			if (set.withzeros) 
 				insert_val = result;
-				debug(HIGH, "Thread [%d]: Gauge change from %lld to %lld\n", worker->index, last_value, insert_val);
-			} else {
-				if (set.withzeros) 
-					insert_val = result;
-				debug(HIGH, "Thread [%d]: Gauge steady at %lld\n", worker->index, insert_val);
-			}
-	    /* Counter Wrap Condition */
-	    } else if (result < last_value) {
-			PT_MUTEX_LOCK(&stats.mutex);
-              stats.wraps++;
-			PT_MUTEX_UNLOCK(&stats.mutex);
-	      if (bits == 32) insert_val = (THIRTYTWO - last_value) + result;
-	      else if (bits == 64) insert_val = (SIXTYFOUR - last_value) + result;
-
+			debug(HIGH, "Thread [%u]: Gauge steady at %llu\n",
+			    worker->index, insert_val);
+		}
+	    } else if (result && (result < last_value)) {
+		PT_MUTEX_LOCK(&stats.mutex);
+		stats.wraps++;
+		PT_MUTEX_UNLOCK(&stats.mutex);
+		switch (bits) {
+		case 32:
+			insert_val = (THIRTYTWO - last_value) + result;
+			break;
+		case 64:
+	      		insert_val = (SIXTYFOUR - last_value) + result;
+			break;
+		}
 #ifdef FEATURES
-			rate = insert_val / timediff(current_time, last_time);
+		rate = insert_val / timediff(current_time, last_time);
 #endif
 
-	      debug(LOW, "*** Counter Wrap (%s@%s) [poll: %llu][last: %llu][insert: %llu]\n",
-	         session.peername, storedoid, result, last_value, insert_val);
+		debug(LOW,
+		    "*** Counter Wrap (%s@%s) [poll: %llu][last: %llu][insert: %llu]\n",
+		    entry->host->s->peername, entry->objoid, result,
+		    last_value, insert_val);
 	    /* Not a counter wrap and this is not the first poll */
-	    } else if ((last_value >= 0) && (init != NEW)) {
+	    } else if (entry->init == LIVE) {
 		insert_val = result - last_value;
+#ifdef FEATURES
 
-#ifdef FEATURES
 			rate = insert_val / timediff(current_time, last_time);
 #endif
-		
-	        /* Print out SNMP result if verbose */
-	        if (set.verbose == DEBUG)
-		  printf("Thread [%d]: (%lld-%lld) = %llu\n", worker->index, result, last_value, insert_val);
-	        if (set.verbose == HIGH)
-		  printf("Thread [%d]: %llu\n", worker->index, insert_val);
-            /* last_value < 0, so this must be the first poll */
-	    } else {
-#ifdef FEATURES
-			/* set up this result for the next poll */
-			entry->last_value = result;
-#endif
-			debug(HIGH, "Thread [%d]: First Poll, Normalizing\n", worker->index);
-	    }
-
-		/* Check for bogus data, either negative or unrealistic */
-	    if (insert_val > entry->maxspeed || result < 0) {
-			debug(LOW, "*** Out of Range (%s@%s) [insert_val: %llu] [oor: %lld]\n",
-				session.peername, storedoid, insert_val, entry->maxspeed);
+		debug(DEBUG, "Thread [%u]: (%llu-%llu) = %llu\n",
+		    worker->index, result, last_value, insert_val);
+	    } else if (insert_val > entry->maxspeed) {
+			debug(LOW,
+			    "*** Out of Range (%s@%s) [insert_val: %llu] [oor: %lld]\n",
+			    entry->host->s->peername, entry->objoid,
+			    insert_val, entry->maxspeed);
 			insert_val = 0;
 #ifdef FEATURES
 			rate = 0;
@@ -325,80 +342,131 @@
 			PT_MUTEX_UNLOCK(&stats.mutex);
 	    }
 
-		if (!(set.dboff)) {
-			if ( (insert_val > 0) || (set.withzeros) ) {
-#ifndef FEATURES
-				/* MP - since we have our own database connection we don't need to lock it anymore */
-				PT_MUTEX_LOCK(&crew->mutex);
+		if (entry->init == NEW) {
+			debug(DEBUG, "Thread [%u]: First Poll, Normalizing\n",
+			    worker->index);
+			entry->init = LIVE;
+		}
+#ifdef FEATURES
+		  else if (entry->init == LIVE && insert_val == 0) {
+			PT_MUTEX_LOCK(&stats.mutex);
+			stats.zero++;
+			PT_MUTEX_UNLOCK(&stats.mutex);
+		}
 #endif
-
+		if (!(set.dboff) && (insert_val || set.withzeros)) {
 #if HAVE_MYSQL
   #if RATE_INSERT
-				snprintf(query, sizeof(query), "INSERT INTO %s (id,dtime,counter,rate) VALUES (%d, NOW(), %llu, %.6f)",
-					entry->table, entry->iid, insert_val, rate);
+			sprintf(query, "(%d,FROM_UNIXTIME(%li),%llu,%.6f),",
+			    entry->iid, current_time.tv_sec, insert_val, rate);
   #else
-				snprintf(query, sizeof(query), "INSERT INTO %s (id,dtime,counter) VALUES (%d, NOW(), %llu)",
-					entry->table, entry->iid, insert_val);
+			sprintf(query, "(%d,FROM_UNIXTIME(%li),%llu),",
+			    entry->iid, current_time.tv_sec, insert_val);
   #endif
-				db_status = mysql_db_insert(query, &mysql);
+			if (entry->dbt->sbuf != NULL)
+				sqlbuf_push(entry->dbt->sbuf, query);
 #elif HAVE_PGSQL
-				snprintf(query, sizeof(query), "INSERT INTO %s VALUES (%d, %li::abstime::timestamp, %llu, %.6f)",
-					entry->table, entry->iid, current_time.tv_sec, insert_val, rate);
-				db_status = pgsql_db_insert(query, pgsql);
+			sprintf(query,
+			    "INSERT INTO %s VALUES (%d, %li::abstime::timestamp, %llu, %.6f)",
+			    entry->dbt->table, entry->iid, current_time.tv_sec,
+			    insert_val, rate);
+			if (pgsql_db_insert(query, pgsql)) {
+				PT_MUTEX_LOCK(&stats.mutex);
+				stats.db_inserts++;
+				PT_MUTEX_UNLOCK(&stats.mutex);
+			} 
 #endif
-				debug(DEBUG, "SQL: %s\n", query);
+		} /* !dboff && (insert_val > 0 || withzeros) */
 
-#ifndef FEATURES
-				/* MP - since we have our own database connection we don't need to lock it anymore */
-				PT_MUTEX_UNLOCK(&crew->mutex);
-#endif
-
-				if (db_status) {
-					PT_MUTEX_LOCK(&stats.mutex);
-					stats.db_inserts++;
-					PT_MUTEX_UNLOCK(&stats.mutex);
-				} 
-			} /* insert_val > 0 or withzeros */	
-		} /* !dboff */
-
+		entry->last_value = result;
 	} /* STAT_SUCCESS */
 
-        if (sessp != NULL) {
+        if (sessp) {
            snmp_sess_close(sessp);
-           if (response != NULL) snmp_free_pdu(response);
+           if (response)
+		   snmp_free_pdu(response);
         }
 
-	debug(DEVELOP, "Thread [%d] locking (update work_count)\n", worker->index);
+	debug(DEVELOP, "Thread [%d] locking (update work_count)\n",
+	    worker->index);
 	PT_MUTEX_LOCK(&crew->mutex);
 	crew->work_count--;
-	/* Only if we received a positive result back do we update the
-	   last_value object */
-	if (poll_status == STAT_SUCCESS) {
-		entry->last_value = result;
-		if (init == NEW) entry->init = LIVE;
-	}
 
 #ifdef FEATURES
 	/* always update the time */
 	entry->last_time = current_time;	
 #endif
 
-	if (crew->work_count <= 0) {
-	    debug(HIGH, "Queue processed. Broadcasting thread done condition.\n");
+	if (crew->work_count == 0) {
+	    debug(HIGH, "Broadcasting thread done condition.\n");
 		PT_COND_BROAD(&crew->done);
 	}
-	debug(DEVELOP, "Thread [%d] unlocking (update work_count)\n", worker->index);
+	debug(DEVELOP, "Thread [%d] unlocking (update work_count)\n",
+	    worker->index);
 
+		fflush(NULL);
 		PT_MUTEX_UNLOCK(&crew->mutex);
     }				/* while(1) */
+#ifdef HAVE_PGSQL
     pthread_cleanup_pop(FALSE);
+#endif
 
 /* Not reached */
-#ifdef FEATURES
-  #if HAVE_MYSQL
-    /* Disconnect from the MySQL Database, exit. */
-    if (!(set.dboff))
-	mysql_dbdisconnect(&mysql);
-  #endif
-#endif
+}
+
+#define SNMPVER(ver) ((ver == 2) ? SNMP_VERSION_2c : SNMP_VERSION_1)
+#define SNMPPORT(port) ((port) ? port : DEFAULT_SNMP_PORT)
+void
+snmp_confighost(struct host_struct *thst, struct config_snmphost *c)
+{
+
+	thst->s = malloc(sizeof(struct snmp_session));
+	snmp_sess_init(thst->s);
+	thst->s->peername = c->host;
+	thst->s->community = c->community;
+	thst->s->community_len = strlen(c->community);
+	thst->s->version = SNMPVER(c->snmp_ver);
+	thst->s->remote_port = SNMPPORT(c->snmp_port);
+	thst->s->retries = c->retries;
+	thst->s->timeout = c->timeout;
+}
+
+unsigned int
+snmp_comparehost(struct snmp_session *s, struct config_snmphost *c)
+{
+
+	if ((strcmp(s->peername, c->host) != 0) ||
+	    (s->community_len != strlen(c->community)) ||
+	    (s->version != SNMPVER(c->snmp_ver)) ||
+	    (strcmp(s->community, c->community) != 0) ||
+	    (s->timeout != c->timeout) ||
+	    (s->retries != c->retries) ||
+	    (s->remote_port != SNMPPORT(c->snmp_port)))
+		return (FALSE);
+
+	return (TRUE);
+}
+#undef SNMPVER
+#undef SNMPPORT
+
+void
+rtg_init_snmp(void)
+{
+
+	init_snmp("RTG");
+}
+
+unsigned int
+rtg_read_objid(struct target_struct *t)
+{
+
+	t->oid = malloc(sizeof(struct rtg_oid));
+	t->oid->OidLen = MAX_OID_LEN;
+	if (!read_objid(t->objoid, t->oid->Oid, &t->oid->OidLen)) {
+		debug(LOW, "cannot parse %s\n", t->objoid);
+		free(t->oid);
+		return (0);
+	}
+
+	return (1);
 }
Index: src/rtgsnmp.h
===========================================================================
*** /dev/null	Wed Nov  3 14:22:00 2004
--- src/rtgsnmp.h	Wed Nov  3 14:26:19 2004
***************
*** 0 ****
--- 1,33 ----
+ /*
+  * Copyright (C) 2004 bill fumerola. All rights reserved.
+  * 
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 
+  * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $Yahoo: //depot/fumerola/rtg-contrib/src/rtgsnmp.h#3 $
+  */ 
+ 
+ void *poller(void *);
+ void rtg_init_snmp(void);
+ unsigned int snmp_comparehost(struct snmp_session *s,
+ 			      struct config_snmphost *c);
+ void snmp_confighost(struct host_struct *nhst, struct config_snmphost *c);
+ unsigned int rtg_read_objid(struct target_struct *t);
